Index: orxonox/branches/openAL/src/story_entities/world.cc
===================================================================
--- orxonox/branches/openAL/src/story_entities/world.cc	(revision 3921)
+++ orxonox/branches/openAL/src/story_entities/world.cc	(revision 4194)
@@ -1,2 +1,3 @@
+
 
 /* 
@@ -39,13 +40,16 @@
 #include "garbage_collector.h"
 #include "animation_player.h"
+#include "particle_engine.h"
 
 #include "command_node.h"
 #include "glmenu_imagescreen.h"
 #include "list.h"
-
-
+#include "game_loader.h"
+
+#include "animation3d.h"
+
+#include "substring.h"
 
 using namespace std;
-
 
 WorldInterface* WorldInterface::singletonRef = 0;
@@ -113,5 +117,49 @@
 }
 
-
+CREATE_FACTORY(World);
+
+World::World( TiXmlElement* root)
+{
+  this->constuctorInit("", -1);
+  this->path = NULL;
+  const char *string;
+  char *name;
+  int id;
+  
+  PRINTF0("Creating a World\n");
+  
+  // identifier
+  string = grabParameter( root, "identifier");
+  if( string == NULL || sscanf(string, "%d", &id) != 1)
+    {
+      PRINTF0("World is missing a proper 'identifier'\n");
+      this->setStoryID( -1);
+    }
+  else setStoryID( id);
+
+  // next id
+  string = grabParameter( root, "nextid");
+  if( string == NULL || sscanf(string, "%d", &id) != 1)
+    {
+      PRINTF0("World is missing a proper 'nextid'\n");
+      this->setStoryID( -1);
+    }
+  else setNextStoryID( id);
+  
+
+  // path
+  string = grabParameter( root, "path");
+  if( string == NULL)
+    {
+      PRINTF0("World is missing a proper 'path'\n");
+      this->setPath( NULL);
+    }
+  else
+    {
+      name = new char[strlen(string + 2)];
+      strcpy( name, string);
+      this->setPath( name);
+    }
+}
 
 /** 
@@ -122,5 +170,6 @@
 World::World (char* name)
 {
-  this->init(name, -1);
+  this->path = NULL;
+  this->constuctorInit(name, -1);
   //NullParent* np = NullParent::getInstance();
 }
@@ -132,5 +181,6 @@
 World::World (int worldID)
 {
-  this->init(NULL, worldID);
+  this->path = NULL;
+  this->constuctorInit(NULL, worldID);
 }
 
@@ -148,8 +198,4 @@
   cn->reset();
 
-  ResourceManager::getInstance()->debug();
-  ResourceManager::getInstance()->unloadAllByPriority(RP_LEVEL);
-  ResourceManager::getInstance()->debug();
-
   delete WorldInterface::getInstance();
 
@@ -158,12 +204,12 @@
   delete this->lightMan;
   delete this->trackManager;
+  delete this->particleEngine;
   TextEngine::getInstance()->flush();
 
-  AnimationPlayer::getInstance()->debug();
   delete AnimationPlayer::getInstance(); // this should be at the end of the unloading sequence.
   //delete garbagecollecor
   //delete animator
 
-
+  ResourceManager::getInstance()->unloadAllByPriority(RP_LEVEL);
 }
 
@@ -177,12 +223,13 @@
    NO LEVEL LOADING HERE - NEVER!
 */
-void World::init(char* name, int worldID)
+void World::constuctorInit(char* name, int worldID)
 {
   this->setClassName ("World");
 
-  this->worldName = name;
+  //this->worldName = name;
+  //this->worldName = new char[strlen(name)+1];
+  //strcpy(this->worldName, name);
   this->debugWorldNr = worldID;
   this->entities = new tList<WorldEntity>();
-  AnimationPlayer::getInstance(); // initializes the animationPlayer
 }
 
@@ -200,4 +247,15 @@
   wi->init(this);
   this->garbageCollector = GarbageCollector::getInstance();
+
+  this->particleEngine = ParticleEngine::getInstance();
+  this->trackManager = TrackManager::getInstance();
+  this->lightMan = LightManager::getInstance();
+  this->nullParent = NullParent::getInstance ();
+  this->nullParent->setName ("NullParent");
+
+  AnimationPlayer::getInstance(); // initializes the animationPlayer
+
+  this->localCamera = new Camera();
+  this->localCamera->setName ("camera");
 }
 
@@ -207,12 +265,133 @@
 */
 ErrorMessage World::load()
-{
-  //  BezierCurve* tmpCurve = new BezierCurve();
-  if(this->debugWorldNr != -1)
-    {
-      // initializing Font
-      this->glmis->step();
+{	
+  PRINTF(3)("> Loading world: '%s'\n", getPath());
+  TiXmlElement* element;
+  GameLoader* loader = GameLoader::getInstance();
+  
+  if( getPath() == NULL)
+    {
+      PRINTF(1)("World has no path specified for loading");
+      return (ErrorMessage){213,"Path not specified","World::load()"};
+    }
+  
+  TiXmlDocument* XMLDoc = new TiXmlDocument( path);
+  // load the campaign document
+  if( !XMLDoc->LoadFile())  
+  {
+    // report an error
+    PRINTF(1)("loading XML File: %s @ %d:%d\n", XMLDoc->ErrorDesc(), XMLDoc->ErrorRow(), XMLDoc->ErrorCol());
+    delete XMLDoc;
+    return (ErrorMessage){213,"XML File parsing error","World::load()"};
+  }
+  
+  // check basic validity
+  TiXmlElement* root = XMLDoc->RootElement();
+  assert( root != NULL);
+  
+  if( root == NULL || root->Value() == NULL || strcmp( root->Value(), "WorldDataFile"))
+    {
+      // report an error
+      PRINTF(1)("Specified XML File is not an orxonox world data file (WorldDataFile element missing)\n");
+      delete XMLDoc;
+      return (ErrorMessage){213,"Path not a WorldDataFile","World::load()"};
+    }
+  
+  // load the parameters
+  // name
+  char* temp;
+  const char* string = grabParameter( root, "name");
+  if( string == NULL)
+    {
+      PRINTF(2)("World is missing a proper 'name'\n");
+      string = "Unknown";
+      temp = new char[strlen(string + 2)];
+      strcpy( temp, string);
+      this->worldName = temp;
+    }
+  else
+    {
+      temp = new char[strlen(string + 2)];
+      strcpy( temp, string);
+      this->worldName = temp;
+    }
+  ////////////////
+  // LOADSCREEN //
+  ////////////////
+  element = root->FirstChildElement("LoadScreen");
+  if (element == NULL)
+    {
+      PRINTF(2)("no LoadScreen specified, loading default\n");
+
+      glmis->setBackgroundImage("pictures/load_screen.jpg");
+      this->glmis->setMaximum(8);
+      this->glmis->draw();
+    }
+  else
+    {
+      this->glmis->load(element);
+      this->glmis->draw();
+    }
+  this->glmis->draw();
+  // find WorldEntities
+  element = root->FirstChildElement("WorldEntities");
+  
+  if( element == NULL)
+    {
+      PRINTF(1)("World is missing 'WorldEntities'\n");
+    }
+  else
+    {
+      element = element->FirstChildElement();
+      // load Players/Objects/Whatever
+      PRINTF(4)("Loading WorldEntities\n");
+      while( element != NULL)
+	{
+	  WorldEntity* created = (WorldEntity*) loader->fabricate( element);
+	  if( created != NULL) this->spawn( created);
+	  // if we load a 'Player' we use it as localPlayer
+	  //todo do this more elegant 
+	  if( element->Value() != NULL && !strcmp( element->Value(), "Player")) localPlayer = (Player*) created;
+	  if( element->Value() != NULL && !strcmp( element->Value(), "SkyBox")) sky = (SkyBox*) created;
+	  element = element->NextSiblingElement();
+	  glmis->step(); //! \todo temporary
+	}
+      PRINTF(4)("Done loading WorldEntities\n");
+    }
+  
+  // find Track
+  /*element = root->FirstChildElement( "Track");
+  if( element == NULL)
+    {
+      PRINTF0("============>>>>>>>>>>>>>>>>>World is missing a 'Track'\n");
+    }
+  else
+    {	
+      //load track
+      PRINTF0("============>>>>>>>>>>>>>>>>Loading Track\n");
+
+      trackManager->loadTrack( element);
+      trackManager->finalize();
+      PRINTF0("============>>>>>>>>>>>>>>>>Done loading Track\n");
+    }*/
+  
+  // free the XML data
+
+  delete XMLDoc;
+  /* GENERIC LOADING PROCESS FINISHED */
+  
+  // bind input
+  Orxonox *orx = Orxonox::getInstance ();
+  orx->getLocalInput()->bind (localPlayer);
+  
+  // bind camera
+  //this->localCamera->bind (localPlayer);
+  this->localPlayer->addChild (this->localCamera);
+  
+  
+  // stuff beyond this point remains to be loaded properly
+ 
       // initializing the TrackManager
-      trackManager = TrackManager::getInstance();
+  this->trackManager = TrackManager::getInstance();
       //trackManager->addPoint(Vector(0,0,0));
       trackManager->addPoint(Vector(150, -35, 5));
@@ -272,298 +451,332 @@
 
       
-      /*monitor progress*/
-      this->glmis->step();
-
-      // LIGHT initialisation
-      lightMan = LightManager::getInstance();
-      lightMan->setAmbientColor(.1,.1,.1);
-      lightMan->addLight();
-      //      lightMan->setAttenuation(1.0, .01, 0.0);
-      //      lightMan->setDiffuseColor(1,1,1);
-      //  lightMan->addLight(1);
-      //  lightMan->setPosition(20, 10, -20);
-      //  lightMan->setDiffuseColor(0,0,0);
-      lightMan->debug();
-
-      switch(this->debugWorldNr)
-	{
-	  /*
-	    this loads the hard-coded debug world. this only for simplicity and will be 
-	    removed by a reald world-loader, which interprets a world-file.
-	    if you want to add an own debug world, just add a case DEBUG_WORLD_[nr] and
-	    make whatever you want...
-	   */
-	case DEBUG_WORLD_0:
-	  {
-	    lightMan->setPosition(-5.0, 10.0, -40.0);
-	    this->nullParent = NullParent::getInstance ();
-	    this->nullParent->setName ("NullParent");
-
-	    // !\todo old track-system has to be removed
-
-	    //create helper for player
-	    //HelperParent* hp = new HelperParent ();
-	    /* the player has to be added to this helper */
-
-	    // create a player
-	    this->localPlayer = new Player ();
-	    this->localPlayer->setName ("player");
-	    this->spawn (this->localPlayer);
-	    /*monitor progress*/
-	    //this->glmis->step();
-	    this->glmis->step();
-
-	    // bind input
-	    Orxonox *orx = Orxonox::getInstance ();
-	    orx->getLocalInput()->bind (this->localPlayer);
+  lightMan->setAmbientColor(.1,.1,.1);
+  lightMan->addLight();
+  //      lightMan->setAttenuation(1.0, .01, 0.0);
+  //      lightMan->setDiffuseColor(1,1,1);
+  //  lightMan->addLight(1);
+  //  lightMan->setPosition(20, 10, -20);
+  //  lightMan->setDiffuseColor(0,0,0);
+  lightMan->debug();
+  lightMan->setPosition(-5.0, 10.0, -40.0);
+  
+  //	    trackManager->setBindSlave(env);
+  PNode* tn = trackManager->getTrackNode();
+  tn->addChild(this->localPlayer);
+  
+  //localCamera->setParent(TrackNode::getInstance());
+  tn->addChild(this->localCamera);
+  localCamera->lookAt(tn);
+  localCamera->setMode(PNODE_MOVEMENT);
+  this->localPlayer->setMode(PNODE_ALL);
+  Vector* cameraOffset = new Vector (0, 5, -10);
+  trackManager->condition(2, LEFTRIGHT, this->localPlayer);
+  
+  this->sky->setParent(this->localCamera);
+
+  // initialize debug coord system
+  objectList = glGenLists(1);
+  glNewList (objectList, GL_COMPILE);
+  
+  //  trackManager->drawGraph(.01);
+  trackManager->debug(2);
+  glEndList();
+
+  terrain = new Terrain("worlds/newGround.obj");
+  terrain->setRelCoor(Vector(0,-10,0));
+  this->spawn(terrain);
+
+
+  ParticleSystem* system = new ParticleSystem(1000, PARTICLE_SPRITE);
+  system->setLifeSpan(.5);
+  system->setConserve(.99);
+  system->setRadius(2, 0, 2, 0);
+
+  ParticleEmitter* emitter = new ParticleEmitter(Vector(-1, 0, 0), M_PI_4, 100, .05);
+  emitter->setParent(this->localPlayer);
+  
+  particleEngine->addConnection(emitter, system);
+}
+
+void World::loadDebugWorld(int worldID)
+{
+  /*monitor progress*/
+  this->glmis->step();
+
+  // LIGHT initialisation
+
+  lightMan->setAmbientColor(.1,.1,.1);
+  lightMan->addLight();
+  //      lightMan->setAttenuation(1.0, .01, 0.0);
+  //      lightMan->setDiffuseColor(1,1,1);
+  //  lightMan->addLight(1);
+  //  lightMan->setPosition(20, 10, -20);
+  //  lightMan->setDiffuseColor(0,0,0);
+  lightMan->debug();
+
+  switch(this->debugWorldNr)
+    {
+      /*
+	this loads the hard-coded debug world. this only for simplicity and will be 
+	removed by a reald world-loader, which interprets a world-file.
+	if you want to add an own debug world, just add a case DEBUG_WORLD_[nr] and
+	make whatever you want...
+      */
+    case DEBUG_WORLD_0:
+      {
+	lightMan->setPosition(-5.0, 10.0, -40.0);
+
+	// !\todo old track-system has to be removed
+
+	//create helper for player
+	//HelperParent* hp = new HelperParent ();
+	/* the player has to be added to this helper */
+
+	// create a player
+	this->localPlayer = new Player ();
+	this->localPlayer->setName ("player");
+	this->spawn (this->localPlayer);
+	/*monitor progress*/
+	//this->glmis->step();
+	this->glmis->step();
+
+	// bind input
+	Orxonox *orx = Orxonox::getInstance ();
+	orx->getLocalInput()->bind (this->localPlayer);
 	    
-	    // bind camera
-	    this->localCamera = new Camera();
-	    this->localCamera->setName ("camera");
+	// bind camera
+	this->localCamera = new Camera();
+	this->localCamera->setName ("camera");
 	    
-	    /*monitor progress*/
-	    this->glmis->step();
-
-	    // Create SkySphere
-	    //	    this->skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
-	    //	    this->skySphere->setName("SkySphere");
-	    //	    this->localCamera->addChild(this->skySphere);
-	    //	    this->spawn(this->skySphere);
-	    skyBox = new SkyBox();
-	    skyBox->setTexture("pictures/sky/skybox", "jpg");
-	    skyBox->setParent(localCamera);
-	    this->spawn(skyBox);
-
-	    /*monitor progress*/
-	    this->glmis->step();
+	/*monitor progress*/
+	this->glmis->step();
+
+	sky = new SkyBox();
+	//	(SkyBox*)(sky)->setTexture("pictures/sky/skybox", "jpg");
+	sky->setParent(localCamera);
+	this->spawn(sky);
+
+	/*monitor progress*/
+	this->glmis->step();
 
 	    
-	    WorldEntity* env = new Environment();
-	    env->setName ("env");
-	    this->spawn(env);
+	WorldEntity* env = new Environment();
+	env->setName ("env");
+	this->spawn(env);
 
 	   
-	    /*
-	    Vector* es = new Vector (10, 5, 0);
-	    Quaternion* qs = new Quaternion ();
-	    WorldEntity* pr = new Primitive(P_CYLINDER);
-	    pr->setName("primitive");
-	    this->spawn(pr, this->localPlayer, es, qs, PNODE_MOVEMENT);
-	    */
-
-	    /*monitor progress*/
-	    this->glmis->step();
-
-	    //	    trackManager->setBindSlave(env);
-	    PNode* tn = trackManager->getTrackNode();
-	    tn->addChild(this->localPlayer);
-	    this->localCamera->lookAt(tn);
-
-	    //localCamera->setParent(TrackNode::getInstance());
-	    tn->addChild(this->localCamera);
-	    //	    localCamera->lookAt(tn);
-	    this->localPlayer->setMode(PNODE_ALL);
-	    //Vector* cameraOffset = new Vector (0, 5, -10);
-	    trackManager->condition(2, LEFTRIGHT, this->localPlayer);
-	    this->glmis->step();
-	    break;
-	  }
-	case DEBUG_WORLD_1:
-	  {
-	    lightMan->setPosition(.0, .0, .0);
-	    lightMan->setAttenuation(1.0, .01, 0.0);
-	    lightMan->setSpecularColor(1,0,0);
-	    this->nullParent = NullParent::getInstance ();
-	    this->nullParent->setName ("NullParent");
-
-	    // create a player
-	    WorldEntity* myPlayer = new Player();
-	    myPlayer->setName ("player");
-	    this->spawn(myPlayer);
-	    this->localPlayer = myPlayer;	    
+	/*
+	  Vector* es = new Vector (10, 5, 0);
+	  Quaternion* qs = new Quaternion ();
+	  WorldEntity* pr = new Primitive(P_CYLINDER);
+	  pr->setName("primitive");
+	  this->spawn(pr, this->localPlayer, es, qs, PNODE_MOVEMENT);
+	*/
+
+	/*monitor progress*/
+	this->glmis->step();
+
+	//	    trackManager->setBindSlave(env);
+	PNode* tn = trackManager->getTrackNode();
+	tn->addChild(this->localPlayer);
+	this->localCamera->lookAt(tn);
+
+	//localCamera->setParent(TrackNode::getInstance());
+	tn->addChild(this->localCamera);
+	//	    localCamera->lookAt(tn);
+	this->localPlayer->setMode(PNODE_ALL);
+	//Vector* cameraOffset = new Vector (0, 5, -10);
+	trackManager->condition(2, LEFTRIGHT, this->localPlayer);
+	this->glmis->step();
+	break;
+      }
+    case DEBUG_WORLD_1:
+      {
+	lightMan->setPosition(.0, .0, .0);
+	lightMan->setAttenuation(1.0, .01, 0.0);
+	lightMan->setSpecularColor(1,0,0);
+	this->nullParent = NullParent::getInstance ();
+	this->nullParent->setName ("NullParent");
+
+	// create a player
+	WorldEntity* myPlayer = new Player();
+	myPlayer->setName ("player");
+	this->spawn(myPlayer);
+	this->localPlayer = myPlayer;	    
 	    
-	    // bind input
-	    Orxonox *orx = Orxonox::getInstance();
-	    orx->getLocalInput()->bind (myPlayer);
+	// bind input
+	Orxonox *orx = Orxonox::getInstance();
+	orx->getLocalInput()->bind (myPlayer);
 	    
-	    // bind camera
-	    this->localCamera = new Camera ();
-	    this->localCamera->setName ("camera");
-	    this->localCamera->lookAt(LightManager::getInstance()->getLight(0));
-	    this->localCamera->setParent(this->localPlayer);
-
-	    // Create SkySphere
-	    skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
-	    this->localPlayer->addChild(this->skySphere);
-	    this->spawn(this->skySphere);
-	    Vector* es = new Vector (20, 0, 0);
-	    Quaternion* qs = new Quaternion ();
-
-	    lightMan->getLight(0)->setParent(trackManager->getTrackNode());
-	    break;
-	  }
-	case DEBUG_WORLD_2:
-	  {
-	    lightMan->setAmbientColor(.1,.1,.1);
-	    lightMan->addLight();
-	    lightMan->setPosition(-5.0, 10.0, -40.0);
-	    this->nullParent = NullParent::getInstance ();
-	    this->nullParent->setName ("NullParent");
-
-	    // !\todo old track-system has to be removed
-
-	    //create helper for player
-	    //HelperParent* hp = new HelperParent ();
-	    /* the player has to be added to this helper */
-
-	    // create a player
-	    this->localPlayer = new Player ();
-	    this->localPlayer->setName ("player");
-	    this->spawn (this->localPlayer);
-	    /*monitor progress*/
-	    //this->glmis->step();	    
-	    this->glmis->step();
-
-	    // bind input
-	    Orxonox *orx = Orxonox::getInstance ();
-	    orx->getLocalInput()->bind (this->localPlayer);
+	// bind camera
+	this->localCamera = new Camera ();
+	this->localCamera->setName ("camera");
+	this->localCamera->lookAt(LightManager::getInstance()->getLight(0));
+	this->localCamera->setParent(this->localPlayer);
+
+	// Create SkySphere
+	sky = new Skysphere("pictures/sky-replace.jpg");
+	this->localPlayer->addChild(this->sky);
+	this->spawn(this->sky);
+	Vector* es = new Vector (20, 0, 0);
+	Quaternion* qs = new Quaternion ();
+
+	lightMan->getLight(0)->setParent(trackManager->getTrackNode());
+	break;
+      }
+    case DEBUG_WORLD_2:
+      {
+	lightMan->setAmbientColor(.1,.1,.1);
+	lightMan->addLight();
+	lightMan->setPosition(-5.0, 10.0, -40.0);
+	this->nullParent = NullParent::getInstance ();
+	this->nullParent->setName ("NullParent");
+
+	// !\todo old track-system has to be removed
+
+	//create helper for player
+	//HelperParent* hp = new HelperParent ();
+	/* the player has to be added to this helper */
+
+	// create a player
+	this->localPlayer = new Player ();
+	this->localPlayer->setName ("player");
+	this->spawn (this->localPlayer);
+	/*monitor progress*/
+	//this->glmis->step();	    
+	this->glmis->step();
+
+	// bind input
+	Orxonox *orx = Orxonox::getInstance ();
+	orx->getLocalInput()->bind (this->localPlayer);
 	    
-	    // bind camera
-	    this->localCamera = new Camera();
-	    this->localCamera->setName ("camera");
-	    this->localCamera->lookAt(this->localPlayer);
-	    this->localCamera->setParent(this->localPlayer);
+	// bind camera
+	this->localCamera = new Camera();
+	this->localCamera->setName ("camera");
+	this->localCamera->lookAt(this->localPlayer);
+	this->localCamera->setParent(this->localPlayer);
 	    
-	    /*monitor progress*/
-	    this->glmis->step();
-
-	    // Create SkySphere
-	    this->skySphere = new Skysphere("../data/pictures/sky-replace.jpg");
-	    this->skySphere->setName("SkySphere");
-	    this->spawn(this->skySphere);
-	    this->localCamera->addChild(this->skySphere);
-	    this->skySphere->setMode(PNODE_MOVEMENT);
-	    /*monitor progress*/
-	    this->glmis->step();
-
-
- 	    WorldEntity* baseNode = new Satellite(Vector(1,0,1), 1.2);
-	    this->localPlayer->addChild(baseNode);
-	    baseNode->setRelCoor(Vector(10.0, 2.0, 1.0));
-	    this->spawn(baseNode);
-
- 	    WorldEntity* secondNode = new Satellite(Vector(0,0,1), 2.0);
-	    baseNode->addChild(secondNode);
-	    secondNode->setRelCoor(Vector(0.0, 0.0, 3.0));
-	    this->spawn(secondNode);
-
-
- 	    WorldEntity* thirdNode = new Satellite(Vector(0,0,1), 1.0);
-	    secondNode->addChild(thirdNode);
-	    thirdNode->setRelCoor(Vector(2.0, 0.0, 0.0));
-	    this->spawn(thirdNode);
+	/*monitor progress*/
+	this->glmis->step();
+
+	// Create SkySphere
+	this->sky = new Skysphere("pictures/sky-replace.jpg");
+	this->sky->setName("SkySphere");
+	this->spawn(this->sky);
+	this->localCamera->addChild(this->sky);
+	this->sky->setMode(PNODE_MOVEMENT);
+	/*monitor progress*/
+	this->glmis->step();
+
+
+	WorldEntity* baseNode = new Satellite(Vector(1,0,1), 1.2);
+	this->localPlayer->addChild(baseNode);
+	baseNode->setRelCoor(Vector(10.0, 2.0, 1.0));
+	this->spawn(baseNode);
+
+	WorldEntity* secondNode = new Satellite(Vector(0,0,1), 2.0);
+	baseNode->addChild(secondNode);
+	secondNode->setRelCoor(Vector(0.0, 0.0, 3.0));
+	this->spawn(secondNode);
+
+
+	WorldEntity* thirdNode = new Satellite(Vector(0,0,1), 1.0);
+	secondNode->addChild(thirdNode);
+	thirdNode->setRelCoor(Vector(2.0, 0.0, 0.0));
+	this->spawn(thirdNode);
 
 	    
+   
+	WorldEntity* c = new Environment();
+	this->localPlayer->addChild(c);
+	c->setRelCoor(Vector(10.0, 2.0, -1.0));
+	this->spawn(c);
+
+
 	    
-
-	    WorldEntity* b = new Environment();
-	    this->localPlayer->addChild(b);
-	    b->setRelCoor(Vector(10.0, 1.0, 1.0));
-	    this->spawn(b);
-
-	   
-	    WorldEntity* c = new Environment();
-	    this->localPlayer->addChild(c);
-	    c->setRelCoor(Vector(10.0, 2.0, -1.0));
-	    this->spawn(c);
-	    
-	    /*	   
-		  KeyFrame* f1 = new KeyFrame;
-		  f1->position = new Vector(-1.1, 0.0, 2.6);
-		  f1->direction = new Quaternion();
-		  f1->time = 1.0;
-		  f1->mode = NEG_EXP;
+	Animation3D* animation = new Animation3D(c);
+	animation->setInfinity(ANIM_INF_REPLAY);
+
+
+	animation->addKeyFrame(Vector(0, 0, 0), Quaternion(0, Vector(0,1,0)), 1.0, ANIM_NEG_EXP, ANIM_LINEAR); 
+	animation->addKeyFrame(Vector(0, 2, 0), Quaternion(M_PI, Vector(0,1,0)), 1.0, ANIM_NEG_EXP, ANIM_LINEAR); 
+	animation->addKeyFrame(Vector(0, 0, 0), Quaternion(0, Vector(0,1,0)), 1.0, ANIM_NEG_EXP, ANIM_LINEAR); 
+
+
+
+
+
+
+	/*	   
+	  KeyFrame* f1 = new KeyFrame;
+	  f1->position = new Vector(-1.1, 0.0, 2.6);
+	  f1->direction = new Quaternion();
+	  f1->time = 1.0;
+	  f1->mode = NEG_EXP;
 		  
 		  
-		  KeyFrame* f2 = new KeyFrame;
-		  f2->position = new Vector(-2.1, 0.0, 2.6);
-		  f2->direction = new Quaternion();
-		  f2->time = 0.1;
-		  f2->mode = NEG_EXP;
+	  KeyFrame* f2 = new KeyFrame;
+	  f2->position = new Vector(-2.1, 0.0, 2.6);
+	  f2->direction = new Quaternion();
+	  f2->time = 0.1;
+	  f2->mode = NEG_EXP;
 		  
-		  KeyFrame* f3 = new KeyFrame;
-		  f3->position = new Vector(10.0, 2.0, -1.0);
-		  f3->direction = new Quaternion();
-		  f3->time = 0.2;
-		  f3->mode = NEG_EXP;
+	  KeyFrame* f3 = new KeyFrame;
+	  f3->position = new Vector(10.0, 2.0, -1.0);
+	  f3->direction = new Quaternion();
+	  f3->time = 0.2;
+	  f3->mode = NEG_EXP;
 		  
-		  KeyFrame* f4 = new KeyFrame;
-		  f4->position = new Vector(10.0, 5.0, -1.0);
-		  f4->direction = new Quaternion();
-		  f4->time = 1.0;
-		  f4->mode = NEG_EXP;
+	  KeyFrame* f4 = new KeyFrame;
+	  f4->position = new Vector(10.0, 5.0, -1.0);
+	  f4->direction = new Quaternion();
+	  f4->time = 1.0;
+	  f4->mode = NEG_EXP;
 		  
 		  
 		  
-		  this->simpleAnimation->animatorBegin();
-		  this->simpleAnimation->selectObject(b);
-		  this->simpleAnimation->setAnimationMode(SINGLE);
-		  this->simpleAnimation->addKeyFrame(f1);
-		  this->simpleAnimation->addKeyFrame(f2);
-		  this->simpleAnimation->start();
-		  this->simpleAnimation->selectObject(c);
-		  this->simpleAnimation->addKeyFrame(f3);
-		  this->simpleAnimation->addKeyFrame(f4);
-		  this->simpleAnimation->start();
-		  this->simpleAnimation->animatorEnd();
-	    */
-
-	    /*
-	    Vector* es = new Vector (10, 5, 0);
-	    Quaternion* qs = new Quaternion ();
-	    WorldEntity* pr = new Primitive(P_CYLINDER);
-	    pr->setName("primitive");
-	    this->spawn(pr, this->localPlayer, es, qs, PNODE_MOVEMENT);
-	    */
-
-	    /*monitor progress*/
-	    this->glmis->step();
-
-	    //	    trackManager->setBindSlave(env);
-	    PNode* tn = trackManager->getTrackNode();
-	    tn->addChild(this->localPlayer);
-
-	    //localCamera->setParent(TrackNode::getInstance());
-	    tn->addChild(this->localCamera);
-	    //	    localCamera->lookAt(tn);
-	    this->localPlayer->setMode(PNODE_ALL);
-	    //Vector* cameraOffset = new Vector (0, 5, -10);
-	    trackManager->condition(2, LEFTRIGHT, this->localPlayer);
-	    this->glmis->step();
-
-	    break;
-	  }
-	default:
-	  printf("World::load() - no world with ID %i found", this->debugWorldNr );
-	}
-    }
-  else if(this->worldName != NULL)
-    {
-
-    }
-
-  // initialize debug coord system
-  objectList = glGenLists(1);
-  glNewList (objectList, GL_COMPILE);
- 
-  //  trackManager->drawGraph(.01);
-  trackManager->debug(2);
-  glEndList();
-
-  terrain = new Terrain("../data/worlds/newGround.obj");
-  terrain->setRelCoor(Vector(0,-10,0));
-  this->spawn(terrain);
-
-}
+	  this->simpleAnimation->animatorBegin();
+	  this->simpleAnimation->selectObject(b);
+	  this->simpleAnimation->setAnimationMode(SINGLE);
+	  this->simpleAnimation->addKeyFrame(f1);
+	  this->simpleAnimation->addKeyFrame(f2);
+	  this->simpleAnimation->start();
+	  this->simpleAnimation->selectObject(c);
+	  this->simpleAnimation->addKeyFrame(f3);
+	  this->simpleAnimation->addKeyFrame(f4);
+	  this->simpleAnimation->start();
+	  this->simpleAnimation->animatorEnd();
+	*/
+
+	/*
+	  Vector* es = new Vector (10, 5, 0);
+	  Quaternion* qs = new Quaternion ();
+	  WorldEntity* pr = new Primitive(P_CYLINDER);
+	  pr->setName("primitive");
+	  this->spawn(pr, this->localPlayer, es, qs, PNODE_MOVEMENT);
+	*/
+
+	/*monitor progress*/
+	this->glmis->step();
+
+	//	    trackManager->setBindSlave(env);
+	PNode* tn = trackManager->getTrackNode();
+	tn->addChild(this->localPlayer);
+
+	//localCamera->setParent(TrackNode::getInstance());
+	tn->addChild(this->localCamera);
+	//	    localCamera->lookAt(tn);
+	this->localPlayer->setMode(PNODE_ALL);
+	//Vector* cameraOffset = new Vector (0, 5, -10);
+	trackManager->condition(2, LEFTRIGHT, this->localPlayer);
+	this->glmis->step();
+
+	break;
+      }
+    default:
+      printf("World::load() - no world with ID %i found", this->debugWorldNr );
+    }
+}
+
 
 
@@ -637,8 +850,8 @@
   
   //GLMenuImageScreen* 
-  this->glmis = GLMenuImageScreen::getInstance();
+  this->glmis = new GLMenuImageScreen();
   this->glmis->init();
   this->glmis->setMaximum(8);
-  this->glmis->draw();
+  //  this->glmis->draw();
  
   PRINTF(3)("World::displayLoadScreen - end\n"); 
@@ -654,6 +867,6 @@
   PRINTF(3)("World::releaseLoadScreen - start\n"); 
   this->glmis->setValue(this->glmis->getMaximum());
-  //SDL_Delay(500);
   PRINTF(3)("World::releaseLoadScreen - end\n"); 
+  delete this->glmis;
 }
 
@@ -745,4 +958,6 @@
 
   TextEngine::getInstance()->draw();
+  particleEngine->draw(this->dtS); //!< \todo should be dts like in the Trunk;
+
   lightMan->draw(); // must be at the end of the drawing procedure, otherwise Light cannot be handled as PNodes //
 }
@@ -840,5 +1055,5 @@
       this->tick ();
       // Update the state
-      this->update ();      
+      this->update ();     
       // Process collision
       this->collide ();
@@ -912,6 +1127,6 @@
       
       /* function to let all entities tick (iterate through list) */
-      float seconds = this->dt / 1000.0;      
-      this->gameTime += seconds;
+      this->dtS = (float)this->dt / 1000.0;      
+      this->gameTime += this->dtS;
       //entity = entities->enumerate(); 
       tIterator<WorldEntity>* iterator = this->entities->getIterator();
@@ -919,16 +1134,16 @@
       while( entity != NULL) 
 	{ 
-	  entity->tick (seconds);
+	  entity->tick (this->dtS);
 	  entity = iterator->nextElement();
 	}
       delete iterator;
-      //skySphere->updatePosition(localCamera->absCoordinate);
-      
+
       /* update tick the rest */
       this->trackManager->tick(this->dt);
       this->localCamera->tick(this->dt);
-      this->garbageCollector->tick(seconds);
-
-      AnimationPlayer::getInstance()->tick(seconds);
+      this->garbageCollector->tick(this->dtS);
+
+      AnimationPlayer::getInstance()->tick(this->dtS);
+      particleEngine->tick(this->dtS);
     }
   this->lastFrame = currentFrame;
@@ -945,5 +1160,5 @@
 {
   this->garbageCollector->update();
-  this->nullParent->update (dt);
+  this->nullParent->update (this->dtS);
 }
 
@@ -1033,12 +1248,32 @@
 bool World::command(Command* cmd)
 {
-  if( !strcmp( cmd->cmd, "view0")) this->localCamera->setViewMode(VIEW_NORMAL);
-  else if( !strcmp( cmd->cmd, "view1")) this->localCamera->setViewMode(VIEW_BEHIND);
-  else if( !strcmp( cmd->cmd, "view2")) this->localCamera->setViewMode(VIEW_FRONT);
-  else if( !strcmp( cmd->cmd, "view3")) this->localCamera->setViewMode(VIEW_LEFT);
-  else if( !strcmp( cmd->cmd, "view4")) this->localCamera->setViewMode(VIEW_RIGHT);
-  else if( !strcmp( cmd->cmd, "view5")) this->localCamera->setViewMode(VIEW_TOP);
+  if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW0)) this->localCamera->setViewMode(VIEW_NORMAL);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW1)) this->localCamera->setViewMode(VIEW_BEHIND);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW2)) this->localCamera->setViewMode(VIEW_FRONT);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW3)) this->localCamera->setViewMode(VIEW_LEFT);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW4)) this->localCamera->setViewMode(VIEW_RIGHT);
+  else if( !strcmp( cmd->cmd, CONFIG_NAME_VIEW5)) this->localCamera->setViewMode(VIEW_TOP);
 
   return false;
 }
 
+void World::setPath( const char* name)
+{
+  if (this->path)
+    delete this->path;
+  if (ResourceManager::isFile(name))
+  {
+    this->path = new char[strlen(name)+1];
+    strcpy(this->path, name);
+  }
+  else
+    {
+      this->path = new char[strlen(ResourceManager::getInstance()->getDataDir()) + strlen(name) +1];
+      sprintf(this->path, "%s%s", ResourceManager::getInstance()->getDataDir(), name);
+    }
+}
+
+const char* World::getPath( void)
+{
+  return path;
+}
